{ Laber-B0T II (c) 2001, 2002 Robert Krause }

unit MainForm_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ComCtrls, INIFiles, ExtCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdIRC;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    Options1: TMenuItem;
    About1: TMenuItem;
    Profil1: TMenuItem;
    Quit1: TMenuItem;
    StatusBar: TStatusBar;
    IRCClient: TIdIRC;
    Panel1: TPanel;
    OnlineButton: TButton;
    OfflineButton: TButton;
    StatusMemo: TMemo;
    SendEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure SendEditKeyPress(Sender: TObject; var Key: Char);
    procedure About1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Profil1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure OnlineButtonClick(Sender: TObject);
    procedure OfflineButtonClick(Sender: TObject);
    procedure IRCClientRaw(Sender: TObject; AUser: TIdIRCUser; ACommand,
      AContent: String; var Suppress: Boolean);
    procedure IRCClientSystem(Sender: TObject; AUser: TIdIRCUser;
      ACmdCode: Integer; ACommand, AContent: String);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

function BlackBox(Text: String):String;
function GetItem(Text:String; ItemNr:Integer; Separator:Char):String;
function CountItems(Text:String; Separator:Char):Integer;
function FoundText(SubString, MainString:String):Boolean;
function Filter(Text:String):String;
function DelItem(Text:String; ItemNr:Integer; Separator:Char):String;
procedure Delay(MSeconds : Longint);

const
  MaxTopics = 100;
  Version = '0.41';

var
  MainForm: TMainForm;
  HomeDir, Profile: String;
  KeyWords : Array[1..MaxTopics] of TStrings;
  Answers : Array[1..MaxTopics] of TStrings;
  Reactions : Array[1..MaxTopics] of String;
  Memory : Array[1..MaxTopics] of Boolean;

implementation

uses AboutForm_Unit, ProfileForm_Unit, OptionsForm_Unit;

{$R *.dfm}

function DelItem(Text:String; ItemNr:Integer; Separator:Char):String;
var i: Integer;
    Temp: String;
begin
  Temp := '';
  for i := 1 to CountItems(Text, Separator) do
    if not (ItemNr = i) then Temp := Temp + GetItem(Text, i, Separator) + Separator;
  Delete(Temp, Length(Temp), 1);
  DelItem := Temp;
end;

function CountItems(Text:String; Separator:Char):Integer;
var Count, i : Integer;
begin
  Count := 0;
  if not (Text = '') then
  begin
    Count := 1;
    for i := 1 to Length(Text) do
      if (Text[i] = Separator) then Inc(Count);
  end;
  CountItems := Count;
end;

function GetItem(Text:String; ItemNr:Integer; Separator:Char):String;
var a, Last, Pos : Integer;
begin
  GetItem := '';
  Pos := 0;
  Last := 1;
  for a := 1 to Length(Text) do
  begin
    if (Text[a] = Separator) then
    begin
      Inc(Pos);
      if (ItemNr = Pos) then
      begin
        GetItem := Copy(Text, Last, a-Last);
        Break;
      end;
      Last := a+1;
    end;
    if ((Length(Text) = a) and (ItemNr = (Pos+1))) then
      GetItem := Copy(Text, Last, Length(Text)-Last+1);
  end;
end;

function FoundText(SubString, MainString:String):Boolean;
var i, j, Found, HaveToFind : Integer;
begin
  FoundText := FALSE;
  SubString := LowerCase(SubString);
  MainString := LowerCase(MainString);
  HaveToFind := CountItems(SubString, '*');
  for i := Length(MainString) downto 1 do
  begin
    if (Ord(MainString[i]) = 39) then Delete(MainString, i, 1);
    if not ((Ord(MainString[i]) >= 97) and (Ord(MainString[i]) <=122) xor (Ord(MainString[i]) >= 48) and (Ord(MainString[i]) <= 57)) xor (Ord(MainString[i]) = 223) xor (Ord(MainString[i]) = 228) xor (Ord(MainString[i]) = 246) xor (Ord(MainString[i]) = 252) then
      MainString[i] := ' ';
  end;
  for i := Length(MainString)-1 downto 1 do
    if ((MainString[i] = ' ') and (MainString[i+1] = ' ')) then Delete(MainString, i, 1);
  if (MainString[Length(MainString)] = ' ') then Delete(MainString, Length(MainString), 1);
  Found := 0;
  for i := 1 to CountItems(MainString, ' ') do
  begin
    for j := CountItems(SubString, '*') downto 1 do
      if (GetItem(SubString, j, '*') = GetItem(MainString, i, ' ')) then
      begin
        Inc(Found);
        SubString := DelItem(SubString, j, '*');
      end;
    if (Found = HaveToFind) then
    begin
      FoundText := TRUE;
      Exit;
    end;
  end;
end;

function Filter(Text:String):String;
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
  if (Pos('[NAME]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'Name', 'LaberBot'), Text, Pos('[NAME]', Text));
    Delete(Text, Pos('[NAME]', Text), Length('[NAME]'));
  end;
  if (Pos('[LOCATION]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'Location', 'Somewhere'), Text, Pos('[LOCATION]', Text));
    Delete(Text, Pos('[LOCATION]', Text), Length('[LOCATION]'));
  end;
  if (Pos('[SIZE]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'Size', '1,70'), Text, Pos('[SIZE]', Text));
    Delete(Text, Pos('[SIZE]', Text), Length('[SIZE]'));
  end;
  if (Pos('[EYECOLOR]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'EyeColor', 'blue'), Text, Pos('[EYECOLOR]', Text));
    Delete(Text, Pos('[EYECOLOR]', Text), Length('[EYECOLOR]'));
  end;
  if (Pos('[HAIRCOLOR]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'HairColor', 'black'), Text, Pos('[HAIRCOLOR]', Text));
    Delete(Text, Pos('[HAIRCOLOR]', Text), Length('[HAIRCOLOR]'));
  end;
  if (Pos('[FIGURE]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'Figure', 'black'), Text, Pos('[FIGURE]', Text));
    Delete(Text, Pos('[FIGURE]', Text), Length('[FIGURE]'));
  end;
  if (Pos('[AGE]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'Age', '18'), Text, Pos('[AGE]', Text));
    Delete(Text, Pos('[AGE]', Text), Length('[AGE]'));
  end;
  if (Pos('[SEX]', Text) <> 0) then
  begin
    if (INI.ReadString('Person', 'Sex', '1') = '0') then Insert('mnnlich', Text, Pos('[SEX]', Text))
      else Insert('weiblich', Text, Pos('[SEX]', Text));
    Delete(Text, Pos('[SEX]', Text), Length('[SEX]'));
  end;
  if (Pos('[HOBBIES]', Text) <> 0) then
  begin
    Insert(INI.ReadString('Person', 'Hobbies', 'nothing'), Text, Pos('[HOBBIES]', Text));
    Delete(Text, Pos('[HOBBIES]', Text), Length('[HOBBIES]'));
  end;
  INI.Free;
  Filter := Text;
end;

function BlackBox(Text: String):String;
var a, b, c: Integer;
    Content, Answer: String;
    INI: TINIFile;
    UnknownReplyFile: TextFile;
begin
  Randomize;
  Content := '';
  Answer := '';
  for a := 1 to MaxTopics do // Alle Schlsselwrter-Themen durchlaufen
    for b := 0 to KeyWords[a].Count-1 do // Alle Schlsselwrter der jeweiligen Themen durchlaufen
      if FoundText(KeyWords[a][b], LowerCase(Text)) then
        begin
          if not (Content = '') then Content := Content + ';';
          Content := Content + IntToStr(a);
        end;
  a := CountItems(Content, ';');
  if (a > 0) then // Thema bestimmen
  begin
    for c := a downto 1 do
    begin
      if (a = 1) then Break;
      b := StrToInt(GetItem(Content, c, ';'));
      if Memory[b] then Content := DelItem(Content, c, ';');
      a := CountItems(Content, ';');
    end;
    b := StrToInt(GetItem(Content, Random(a)+1, ';'));
    if (Memory[b]) then
    begin
      Answer := Answers[2][Random(Answers[2].Count)]
    end else
    begin
      Memory[b] := TRUE;
      Content := Reactions[b];
      a := CountItems(Content, ';');
      Content := GetItem(Content, Random(a)+1, ';');
      if (Pos('+', Content) <> 0) then
      begin
        for b := 1 to CountItems(Content, '+') do
          if (Answer = '') then Answer := Answers[StrToInt(GetItem(Content, b, '+'))][Random(Answers[StrToInt(GetItem(Content, b, '+'))].Count)]
            else Answer := Answer + ' ' + Answers[StrToInt(GetItem(Content, b, '+'))][Random(Answers[StrToInt(GetItem(Content, b, '+'))].Count)];
      end else Answer := Answers[StrToInt(Content)][Random(Answers[StrToInt(Content)].Count)];
    end;
  end else
  begin
    Answer := Answers[1][Random(Answers[1].Count)];
    INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
    if (INI.ReadString('Debug', 'SaveUnknownReply', 'TRUE') = 'TRUE') then
    begin
      AssignFile(UnknownReplyFile, Homedir + 'UnknownReply.log');
      if not FileExists(Homedir + 'UnknownReply.log') then ReWrite(UnknownReplyFile)
        else Append(UnknownReplyFile);
      WriteLn(UnknownReplyFile, Text);
      CloseFile(UnknownReplyFile);
    end;
    INI.Free;
  end;
  Answer := Filter(Answer);
  BlackBox := Answer;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i, a : Integer;
    Data : TextFile;
    Line : String;
begin
  MainForm.Caption := 'Laber-B0T II Version ' + Version + ' (c) 2001, 2002 CREEQ';
  HomeDir := GetCurrentDir + '\';
  Profile := '';
  StatusBar.Panels[0].Text := 'Profile: [none]';
  // Initialisierung und Laden der Schlsselwrter
  for i := 1 to MaxTopics do KeyWords[i] := TStringList.Create;
  AssignFile(Data, 'KeyWords.LB2');
  Reset(Data);
  while not EoF(Data) do
  begin
    ReadLn(Data, Line);
    if (Pos(' = ', Line) <> 0) then
      for a := 1 to CountItems(Copy(Line, Pos(' = ', Line)+3, Length(Line)-Pos(' = ', Line)-2), ';') do
        KeyWords[StrToInt(Copy(Line, 1, Pos(' ', Line)-1))].Add(GetItem(Copy(Line, Pos(' = ', Line)+3, Length(Line)-Pos(' = ', Line)-2), a, ';'));
  end;
  CloseFile(Data);
  // Initialisierung und Laden der Antworten
  for i := 0 to MaxTopics do Answers[i] := TStringList.Create;
  AssignFile(Data, 'Answers.LB2');
  Reset(Data);
  while not EoF(Data) do
  begin
    ReadLn(Data, Line);
    if (Pos(' = ', Line) <> 0) then
      for a := 1 to CountItems(Copy(Line, Pos(' = ', Line)+3, Length(Line)-Pos(' = ', Line)-2), ';') do
        Answers[StrToInt(Copy(Line, 1, Pos(' ', Line)-1))].Add(GetItem(Copy(Line, Pos(' = ', Line)+3, Length(Line)-Pos(' = ', Line)-2), a, ';'));
  end;
  CloseFile(Data);
  // Initialisierung und Laden der Reaktionen
  AssignFile(Data, 'Reactions.LB2');
  Reset(Data);
  while not EoF(Data) do
  begin
    ReadLn(Data, Line);
    if (Pos(' = ', Line) <> 0) then
      Reactions[StrToInt(Copy(Line, 1, Pos(' ', Line)-1))] := Copy(Line, Pos(' = ', Line)+3, Length(Line)-Pos(' = ', Line)-2);
  end;
  CloseFile(Data);
end;

procedure TMainForm.SendEditKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key = #13) and not (SendEdit.Text = '')) then
  begin
    if IRCClient.Connected then IRCClient.Raw(SendEdit.Text);
    SendEdit.Clear;
  end;
end;

procedure Delay(MSeconds : Longint);
var FTickCount : Longint;
Begin
  FTickCount := GetTickCount;
  Repeat
    Application.ProcessMessages;
  Until ((GetTickCount-FTickCount) >= MSeconds);
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutForm.VersionLabel.Caption := 'Version ' + Version;
  AboutForm.ShowModal;      
end;

procedure TMainForm.Quit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Profil1Click(Sender: TObject);
begin
  ProfileForm.ShowModal;
end;

procedure TMainForm.Options1Click(Sender: TObject);
begin
  OptionsForm.ShowModal;
end;

procedure TMainForm.OnlineButtonClick(Sender: TObject);
var INI: TINIFile;
begin
  StatusMemo.Clear;
  OfflineButton.Enabled := TRUE;
  OnlineButton.Enabled := FALSE;
  INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
  IRCClient.Nick := INI.ReadString('IRC', 'NickName', 'LaberBot');
  IRCClient.AltNick := INI.ReadString('IRC', 'NickName', 'LaberBot') + '_';
  IRCClient.Host := INI.ReadString('IRC', 'Server', 'irc.isdnet.fr');
  IRCClient.Port := StrToInt(INI.ReadString('IRC', 'Port', '6667'));
  IRCClient.RealName := INI.ReadString('IRC', 'RealName', 'Laber-B0T' + ' ' + Version);
  IRCClient.Username := INI.ReadString('IRC', 'Ident', 'LaberB0T');
  INI.Free;
  IRCClient.Connect();
end;

procedure TMainForm.OfflineButtonClick(Sender: TObject);
begin
  IRCClient.Quit('Client Quit');
  OnlineButton.Enabled := TRUE;
  OfflineButton.Enabled := FALSE;
end;

procedure TMainForm.IRCClientRaw(Sender: TObject; AUser: TIdIRCUser;
  ACommand, AContent: String; var Suppress: Boolean);
var LogFile, MemoryFile, DebugFile: TextFile;
    i: Integer;
    Line, Answer, Msg: String;
    INI: TIniFile;
begin
  INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
  if (INI.ReadString('Debug', 'DebugMode', 'FALSE') = 'TRUE') then
  begin
    AssignFile(DebugFile, Homedir + 'Debug.log');
    if not FileExists(Homedir + 'Debug.log') then ReWrite(DebugFile)
      else Append(DebugFile);
    WriteLn(DebugFile, AContent);
    CloseFile(DebugFile);
  end;
  StatusMemo.Lines.Add(AContent);
  Msg := Copy(AContent, Pos(':', AContent)+1, Length(AContent)-Pos(':', AContent));
  if ((ACommand = 'PRIVMSG') and not (Copy(AContent, 1, 1) = '#')) then
  begin
    if not DirectoryExists(HomeDir + AUser.Nick) then CreateDir(HomeDir + AUser.Nick);
    AssignFile(MemoryFile, Homedir + AUser.Nick + '\' + 'memory.LB2');
    if FileExists(Homedir + AUser.Nick + '\' + 'memory.LB2') then
    begin
      Reset(MemoryFile);
      i := 1;
      while not EoF(MemoryFile) do
      begin
        ReadLn(MemoryFile, Line);
        case Line[1] of
          '0': Memory[i] := FALSE;
          '1': Memory[i] := TRUE;
        end;
        Inc(i);
      end;
    end else
    begin
      for i := 1 to MaxTopics do Memory[i] := FALSE;
      ReWrite(MemoryFile);
      for i := 1 to MaxTopics do
        case Memory[i] of
          FALSE: Writeln(MemoryFile, '0');
          TRUE: Writeln(MemoryFile, '1');
        end;
    end;
    CloseFile(MemoryFile);
    Answer := BlackBox(Msg);
    ReWrite(MemoryFile);
    for i := 1 to MaxTopics do
      case Memory[i] of
        FALSE: Writeln(MemoryFile, '0');
        TRUE: Writeln(MemoryFile, '1');
      end;
    CloseFile(MemoryFile);
    AssignFile(LogFile, Homedir + AUser.Nick + '\' + AUser.Nick + '.log');
    if not FileExists(Homedir + AUser.Nick + '\' + AUser.Nick + '.log') then ReWrite(LogFile)
      else Append(LogFile);
    WriteLn(LogFile, '[' + TimeToStr(time) + '] <' + AUser.Nick + '> ' + Msg);
    if (INI.ReadString('Command', 'PasteQuerys', 'FALSE') = 'TRUE') then IRCClient.Say(INI.ReadString('IRC', 'CommandChannel', '#Laber-B0T'), '14,0<-- 1' + AUser.Nick + '14: 12' + Msg);
    Delay(Length(Answer)*StrToInt(INI.ReadString('Misc', 'CharTime', '300')));
    WriteLn(LogFile, '[' + TimeToStr(time) + '] <' + INI.ReadString('IRC', 'NickName', 'LaberBot') + '> ' + Answer);
    if (INI.ReadString('Command', 'PasteQuerys', 'FALSE') = 'TRUE') then IRCClient.Say(INI.ReadString('IRC', 'CommandChannel', '#Laber-B0T'), '14,0--> 1' + AUser.Nick + '14: 12' + Answer);
    CloseFile(LogFile);
    IRCClient.Say(AUser.Nick, Answer);
  end else if (Copy(AContent, 1, Length(INI.ReadString('IRC', 'CommandChannel', '#Laber-B0T'))) = INI.ReadString('IRC', 'CommandChannel', '#Laber-B0T')) then
  begin
    if (LowerCase(GetItem(Msg, 1, ' ')) = '!join') then IRCClient.Join(GetItem(Msg, 2, ' '), GetItem(Msg, 3, ' '));
  end;
  INI.Free;
end;

procedure TMainForm.IRCClientSystem(Sender: TObject; AUser: TIdIRCUser;
  ACmdCode: Integer; ACommand, AContent: String);
var INI: TINIFile;
begin
  INI := TINIFile.Create(HomeDir + 'PROFILES\' + Profile + '.ini');
  if (ACmdCode = 376) then IRCClient.Join(INI.ReadString('IRC', 'CommandChannel', '#Laber-B0T'));
  INI.Free;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var i : Integer;
begin
  // TStrings freigeben
  for i := 1 to MaxTopics do KeyWords[i].Free;
  for i := 1 to MaxTopics do Answers[i].Free;
  while IRCClient.Connected do
  begin
    IRCClient.Quit('Client Quit');
    Delay(100);
  end;
end;

end.
